From 924495183297e6936ea29589da60bf98a3d344e1 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Jul 21 2017 15:49:54 +0000
Subject: [PATCH 902/1001] Refactor the notification icon


---

diff --git a/hubs/static/js/utils.js b/hubs/static/js/utils.js
index cefe086..63f3ed0 100644
--- a/hubs/static/js/utils.js
+++ b/hubs/static/js/utils.js
@@ -38,7 +38,8 @@ function setup_sse(url) {
       // Auto-update is disabled.
       return;
     }
-    var sseSource = new Hubs.ReconnectingEventSource(url);
+    var sseSource = new Hubs.ReconnectingEventSource(url),
+        notifTimeout = null;
     sseSource.addEventListener("hubs:widget-updated", function(e) {
         var widget = $("#widget-" + e.data);
         if (widget.length === 0) { return; }
@@ -57,16 +58,20 @@ function setup_sse(url) {
             },
         });
     });
-    // On each message, switch the notification favicon to green for 15s.
-    sseSource.addEventListener("message", function(e) {
-        Notificon('#33ff00');  // green
-        setTimeout(function(){ Notificon(); }, 15000)
-    });
-    // On error, switch the notification favicon to red.
-    sseSource.addEventListener("error", function(e) {
-        Notificon('#eb361e');  // red
-        setTimeout(function(){ Notificon(); }, 15000)
-    });
+    function change_notify_icon(color) {
+        // Set the notify icon for 5s
+        if (color == "green") {
+            color = "#33ff00";
+        } else if (color == "red") {
+            color = "#eb361e";
+        }
+        Notificon(color);
+        if (notifTimeout) { clearTimeout(notifTimeout); }
+        notifTimeout = setTimeout(function(){ Notificon(); }, 5000)
+    }
+    // Icon to red on disconnect, icon to green on reconnect.
+    sseSource.addEventListener("error", function() { change_notify_icon("red"); });
+    sseSource.addEventListener("open", function() { change_notify_icon("green"); });
     // Make it accessible by other components on the page.
     document.sseSource = sseSource;
   }

